(* Identifiers - variables or constructors *)

(*
$File: Common/IDENT.sml $
$Date: 1991/11/08 13:22:40 $
$Revision: 1.17 $
$Locker:  $
*)

(*$IDENT*)
signature IDENT =
  sig
    eqtype strid

    eqtype longid
    val pr_longid : longid -> string

    eqtype id
    val inventId: unit -> id
    and pr_id : id -> string

    val mk_Id: string -> id			(* NEW PARSER *)
    val mk_LongId: string list -> longid	(* NEW PARSER *)
    val inventLongId: unit -> longid		(* NEW PARSER *)
    val idToLongId: id -> longid

    val unqualified: longid -> bool
    val decompose: longid -> strid list * id
    val decompose0: longid -> id

    val < : id * id -> bool


   (* Identifiers needed for derived form conversion. *)

    val id_NIL: id
    val id_CONS: id
    val id_TRUE: id
    val id_FALSE: id
    val id_REF: id
    val id_PRIM: id
    val id_IT: id

   (* Bogus identifier *)
    val bogus: longid
  end;
