(*
$File: Compiler/Apply.sml $
$Date: 1991/12/03 15:54:35 $
$Revision: 1.1 $
$Locker:  $
*)

(*$Apply: OBJECTS CRASH APPLY*)
functor Apply(structure Objects: OBJECTS
	      structure Crash: CRASH
	     ): APPLY =
  struct
    open Objects

    fun dePair object = (select(0, object), select(1, object))

    fun intPairToInt(f, object) =
      let
	val (arg1, arg2) = dePair object
      in
	integer(f(deInteger arg1, deInteger arg2))
      end

    fun bool b = vector [void, integer(if b then 1 else 0)]

    fun apply(n, object) =
      case n
	of 0 => bool(equal(dePair object))
	 | 14 => intPairToInt(op +, object)
         | 15 => intPairToInt(op -, object)
	 | 16 => intPairToInt(op *, object)
	 | _ => Crash.unimplemented("apply(#" ^ Int.string n ^ ")")
  end;
