(* Much akin to the dynamic basis of the semantics document, but some of
   the entities are split into two. For example, the dynamic semantics
   maps variables to objects, where we have two mappings: variables->lvars
   and lvars->objects, since the lambda compiler sits in the middle. *)

(*
$File: Compiler/COMPILER_DYNAMIC_BASIS.sml $
$Date: 1991/12/03 15:54:35 $
$Revision: 1.1 $
$Locker:  $
*)

(*$COMPILER_DYNAMIC_BASIS: DYNAMIC_BASIS*)

signature COMPILER_DYNAMIC_BASIS =
  sig
    include DYNAMIC_BASIS		(* Must match this... *)

    type CEnv				(* compiler env: var->lvar *)
    type DEnv				(* dynamic env: lvar->object *)

    val env: CEnv * DEnv -> Env
    val deEnv: Env -> CEnv * DEnv
  end;
