(*
$File: Compiler/CompilerDynamicBasis.sml $
$Date: 1991/12/03 15:54:35 $
$Revision: 1.1 $
$Locker:  $
*)

(*$CompilerDynamicBasis:
	COMPILER_ENV DYNAMIC_ENV PRETTYPRINT COMPILER_DYNAMIC_BASIS
 *)
functor CompilerDynamicBasis(structure CompilerEnv: COMPILER_ENV
			     structure DynamicEnv: DYNAMIC_ENV

			     structure PP: PRETTYPRINT
			     sharing type CompilerEnv.StringTree
			                  = DynamicEnv.StringTree
					  = PP.StringTree
			    ): COMPILER_DYNAMIC_BASIS =
  struct
    type CEnv = CompilerEnv.CEnv
    type DEnv = DynamicEnv.DEnv

    type Env = {compilerEnv: CEnv, dynamicEnv: DEnv}
    type DynamicBasis = Env

    fun env(ce, de) = {compilerEnv=ce, dynamicEnv=de}
    fun deEnv{compilerEnv=ce, dynamicEnv=de} = (ce, de)
      
    fun E_in_B x = x
    fun E_of_B x = x
    fun B_plus_B({compilerEnv=ce, dynamicEnv=de},
		 {compilerEnv=ce', dynamicEnv=de'}
		) =
      {compilerEnv=CompilerEnv.plus(ce, ce'),
       dynamicEnv=DynamicEnv.plus(de, de')
      }

    val emptyDynamicBasis =
      env(CompilerEnv.emptyCEnv, DynamicEnv.emptyDEnv)

    val initialDynamicBasis =
      env(CompilerEnv.initialCEnv, DynamicEnv.emptyDEnv)

    type StringTree = PP.StringTree
    fun layoutDynamicBasis{compilerEnv=ce, dynamicEnv=de} =
      PP.NODE{start="{", finish="}", indent=1, childsep=PP.RIGHT "; ",
	      children=[CompilerEnv.layoutCEnv ce,
			DynamicEnv.layoutDEnv de
		       ]
	     }
  end;
