infix  3 o 
infix  4 = <> < > <= >= ==
infix  5 @
infixr 5 ::
infix  6 + - ^
infix  7 div mod / *

exception Abs
exception Ord
exception Chr
exception Div
exception Mod
exception Quot
exception Prod
exception Neg
exception Sum
exception Diff
exception Floor
exception Sqrt
exception Exp
exception Ln
exception Io of string
exception Match
exception Bind
exception Interrupt
exception NoCode

datatype bool = true | false

val not = fn true => false | false => true

datatype 'a list = nil | op :: of 'a * 'a list
							
fun op = (x: ''a, y: ''a): bool = prim(0, (x, y))
and floor(x: real): int = prim(1, (x, Floor))
and real(x: int): real = prim(2, x)
and sqrt(x: real): real = prim(3, (x, Sqrt))
and sin(x: real): real = prim(4, x)
and cos(x: real): real = prim(5, x)
and arctan(x: real): real = prim(6, x)
and exp(x: real): real = prim(7, (x, Exp))
and ln(x: real): real = prim(8, (x, Ln))
and size(x: string): int = prim(9, x)
and chr(x: int): string = prim(10, (x, Chr))
and ord(x: string): int = prim(11, (x, Ord))
and explode(x: string): string list = prim(12, x)
and implode(x: string list): string = prim(13, x)
and (x: int) + (y: int): int = prim(14, (x, y, Sum))
and (x: int) - (y: int): int = prim(15, (x, y, Diff))
and (x: int) * (y: int): int = prim(16, (x, y, Prod))
and (x: real) / (y: real): real = prim(17, (x, y, Quot))
and (x: int) div (y: int): int = prim(18, (x, y, Div))
and (x: int) mod (y: int): int = prim(19, (x, y, Mod))
and (x: int) < (y: int): bool = prim(20, (x, y))
and (x: int) > (y: int): bool = prim(21, (x, y))
and ~(x: int): int = prim(22, x)
and == (x:'a, y:'a): bool = raise NoCode

fun (f o g) x = f(g x)

val op <> = not o (op =)
val op <= = not o (op >)
val op >= = not o (op <)

fun nil @ M = M
  | (x :: L) @ M = x :: (L @ M)

fun s ^ s' = implode(explode s @ explode s')

fun map F nil = nil
  | map F (x :: L) = F x :: map F L

fun rev nil = nil
  | rev (x :: L) = rev L @ [x]

fun !(ref x) = x;
